#include<p18f452.h>
#include <delays.h>
volatile unsigned int cpt=0;// compteur d'interruption
volatile unsigned char flag;

//sous prog d'int
#pragma interrupt it_sur_rb0
void it_sur_rb0(void)
{
if (INTCONbits.INT0IF)
{cpt++;
flag = ~flag; // toggle
INTCONbits.INT0IF=0;}
}

//code asm pour gestion des int en c
#pragma code vecteur_d_IT=0x08 
void une_fonction(void)
{_asm
goto it_sur_rb0
_endasm}

#pragma code 


void main (void)
{
flag = 0;
TRISBbits.TRISB0=1;//rb0 en entree
TRISBbits.TRISB2=0;//rb2 en sortie(led)


RCONbits.IPEN=1; //Interruption prioritaires actives
INTCON2bits.INTEDG0=0;//front descendant sur RB0
INTCONbits.GIEH = 1;// Toutes les IT dmasques hautes priorits autorises
INTCONbits.GIEL = 1;// Toutes les IT dmasques basses pririts autorises
INTCONbits.INT0IE=1;//activation d'int sur rb0

while(1)// boucle infinie
 {
  if(flag == 1) 
   {
   PORTBbits.RB2 = !PORTBbits.RB2; //on inverse rb2
   Delay10KTCYx(10);
  // Delay_ms(600); // anti-rebonds du B.P
   flag = 0;
  }
 }
}
